/*
 * Harbor API
 * These APIs provide services for manipulating Harbor project.
 *
 * OpenAPI spec version: 2.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.19
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.HarborApi) {
      root.HarborApi = {};
    }
    root.HarborApi.StatisticMap = factory(root.HarborApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The StatisticMap model module.
   * @module model/StatisticMap
   * @version 2.0
   */

  /**
   * Constructs a new <code>StatisticMap</code>.
   * @alias module:model/StatisticMap
   * @class
   */
  var exports = function() {
  };

  /**
   * Constructs a <code>StatisticMap</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/StatisticMap} obj Optional instance to populate.
   * @return {module:model/StatisticMap} The populated <code>StatisticMap</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('private_project_count'))
        obj.privateProjectCount = ApiClient.convertToType(data['private_project_count'], 'Number');
      if (data.hasOwnProperty('private_repo_count'))
        obj.privateRepoCount = ApiClient.convertToType(data['private_repo_count'], 'Number');
      if (data.hasOwnProperty('public_project_count'))
        obj.publicProjectCount = ApiClient.convertToType(data['public_project_count'], 'Number');
      if (data.hasOwnProperty('public_repo_count'))
        obj.publicRepoCount = ApiClient.convertToType(data['public_repo_count'], 'Number');
      if (data.hasOwnProperty('total_project_count'))
        obj.totalProjectCount = ApiClient.convertToType(data['total_project_count'], 'Number');
      if (data.hasOwnProperty('total_repo_count'))
        obj.totalRepoCount = ApiClient.convertToType(data['total_repo_count'], 'Number');
    }
    return obj;
  }

  /**
   * The count of the private projects which the user is a member of.
   * @member {Number} privateProjectCount
   */
  exports.prototype.privateProjectCount = undefined;

  /**
   * The count of the private repositories belonging to the projects which the user is a member of.
   * @member {Number} privateRepoCount
   */
  exports.prototype.privateRepoCount = undefined;

  /**
   * The count of the public projects.
   * @member {Number} publicProjectCount
   */
  exports.prototype.publicProjectCount = undefined;

  /**
   * The count of the public repositories belonging to the public projects which the user is a member of.
   * @member {Number} publicRepoCount
   */
  exports.prototype.publicRepoCount = undefined;

  /**
   * The count of the total projects, only be seen when the is admin.
   * @member {Number} totalProjectCount
   */
  exports.prototype.totalProjectCount = undefined;

  /**
   * The count of the total repositories, only be seen when the user is admin.
   * @member {Number} totalRepoCount
   */
  exports.prototype.totalRepoCount = undefined;


  return exports;

}));
